/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.iceberg;

import javax.microedition.lcdui.*;

/**
 * @author DDDEN!SSS
 */
public class Light {
    public static int xReal=0, yReal=0, zReal=4096;
    public static int x=0, y=0, z=4096;
    
    public static void setLight(int X, int Y, int Z) {
        xReal = X;
        yReal = Y;
        zReal = Z;
        float length = (float)Math.sqrt( xReal*xReal + yReal*yReal + zReal*zReal );
        
        xReal <<= 12;
        yReal <<= 12;
        zReal <<= 12;
        
        xReal /= length;
        yReal /= length;
        zReal /= length;
        
        x = xReal;
        y = yReal;
        z = zReal;
    }
    
    
    public static final void setMatrix(Matrix m) {
        x = (xReal*m.m00 + yReal*m.m01 + zReal*m.m02)>>12;
        y = (xReal*m.m10 + yReal*m.m11 + zReal*m.m12)>>12;
        z = (xReal*m.m20 + yReal*m.m21 + zReal*m.m22)>>12;
    }
    
    
    
    
    
    
    public static final int color(int c, Normal n) {
        int r = (c>>16) & 0xff;
        int g = (c>>8)& 0xff;
        int b = c & 0xff;
        
        int a = (n.nx*x + n.ny*y + n.nz*z) >> 12;
        
        if(a>0) {
            a=0;
        }
        if(a<-4096) {
            a=-4096;
        }
        
        
        r = (r*-a)>>12;
        g = (g*-a)>>12;
        b = (b*-a)>>12;
        
        
        c = r;
        c <<= 8;
        c |= g;
        c <<= 8;
        c |= b;
        
        return c;
    }
    
    
    
    
    
    
}