package com.iceberg;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


/**
 * @author DDDEN!SSS
 */
public class Matrix {
    private static final int fp = 4096; //fixedpoint
    
    public static final float[] sin = sin();
    public static final float[] cos = cos();
    
    public int m00 = fp; //x-вектор. X-координата
    public int m01; //y-вектор. X-координата
    public int m02; //z-вектор. X-координата
    public int m03; //x-позиция
    
    public int m10; //x-вектор. Y-координата
    public int m11 = fp; //y-вектор. Y-координата
    public int m12; //z-вектор. Y-координата
    public int m13; //y-позиция
    
    public int m20; //x-вектор. Z-координата
    public int m21; //y-вектор. Z-координата
    public int m22 = fp; //z-вектор. Z-координата
    public int m23; //z-позиция
    
    
    
    
    private float t00 = 1; //x-вектор. X-координата
    private float t01; //y-вектор. X-координата
    private float t02; //z-вектор. X-координата
    public float t03; //x-позиция
    
    private float t10; //x-вектор. Y-координата
    private float t11 = 1; //y-вектор. Y-координата
    private float t12; //z-вектор. Y-координата
    public float t13; //y-позиция
    
    private float t20; //x-вектор. Z-координата
    private float t21; //y-вектор. Z-координата
    private float t22 = 1; //z-вектор. Z-координата
    public float t23; //z-позиция
    
    private final float t30 = 0;
    private final float t31 = 0;
    private final float t32 = 0;
    private final float t33 = 1;
    
    
    private static float[] sin() {
        float[] sin = new float[360];
        for(int i=0; i<sin.length; i++) {
            sin[i] = (float)Math.sin( Math.toRadians(i) );
        }
        return sin;
    }
    private static float[] cos() {
        float[] cos = new float[360];
        for(int i=0; i<cos.length; i++) {
            cos[i] = (float)Math.cos( Math.toRadians(i) );
        }
        return cos;
    }
    
    
    
    
    
    
    
    
    public void setIdentity() {
        t00 = 1;
        t01 = 0;
        t02 = 0;
        t03 = 0;
        
        t10 = 0;
        t11 = 1;
        t12 = 0;
        t13 = 0;
        
        t20 = 0;
        t21 = 0;
        t22 = 1;
        t23 = 0;
        toFP();
    }
    private static final int angle(int i) {
        if(i<0) {
            i+=360;
        }
        if(i>360) {
            i-=360;
        }
        return i;
    }
    public void rotationX(int i) {
        i = angle(i);
        t00 = 1;
        t01 = 0;
        t02 = 0;
        t03 = 0;
        
        t10 = 0;
        t11 = cos[i];
        t12 = sin[i];
        t13 = 0;
        
        t20 = 0;
        t21 = -sin[i];
        t22 = cos[i];
        t23 = 0;
        toFP();
    }
    public void rotationY(int i) {
        i = angle(i);
        t00 = cos[i];
        t01 = 0;
        t02 = -sin[i];
        t03 = 0;
        
        t10 = 0;
        t11 = 1;
        t12 = 0;
        t13 = 0;
        
        t20 = sin[i];
        t21 = 0;
        t22 = cos[i];
        t23 = 0;
        toFP();
    }
    public void rotationZ(int i) {
        i = angle(i);
        t00 = cos[i];
        t01 = sin[i];
        t02 = 0;
        t03 = 0;
        
        t10 = -sin[i];
        t11 = cos[i];
        t12 = 0;
        t13 = 0;
        
        t20 = 0;
        t21 = 0;
        t22 = 1;
        t23 = 0;
        toFP();
    }
    
    public void mul(Matrix m) {
        float tt00 = t00*m.t00 + t01*m.t10 + t02*m.t20 + t03*m.t30;
        float tt01 = t00*m.t01 + t01*m.t11 + t02*m.t21 + t03*m.t31;
        float tt02 = t00*m.t02 + t01*m.t12 + t02*m.t22 + t03*m.t32;
        float tt03 = t00*m.t03 + t01*m.t13 + t02*m.t23 + t03*m.t33;
        
        float tt10 = t10*m.t00 + t11*m.t10 + t12*m.t20 + t13*m.t30;
        float tt11 = t10*m.t01 + t11*m.t11 + t12*m.t21 + t13*m.t31;
        float tt12 = t10*m.t02 + t11*m.t12 + t12*m.t22 + t13*m.t32;
        float tt13 = t10*m.t03 + t11*m.t13 + t12*m.t23 + t13*m.t33;
        
        float tt20 = t20*m.t00 + t21*m.t10 + t22*m.t20 + t23*m.t30;
        float tt21 = t20*m.t01 + t21*m.t11 + t22*m.t21 + t23*m.t31;
        float tt22 = t20*m.t02 + t21*m.t12 + t22*m.t22 + t23*m.t32;
        float tt23 = t20*m.t03 + t21*m.t13 + t22*m.t23 + t23*m.t33;
        
        t00 = tt00;
        t01 = tt01;
        t02 = tt02;
        t03 = tt03;
        
        t10 = tt10;
        t11 = tt11;
        t12 = tt12;
        t13 = tt13;
        
        t20 = tt20;
        t21 = tt21;
        t22 = tt22;
        t23 = tt23;
        
        toFP();
        // [ m00 m01 m02 m03 ]    [ m00 m01 m02 m03 ]
        // [ m10 m11 m12 m13 ]    [ m10 m11 m12 m13 ]
        // [ m20 m21 m22 m23 ]    [ m20 m21 m22 m23 ]
        // [ m30 m31 m32 m33 ]    [ m30 m31 m32 m33 ]
    }
    
    
    public void set(Matrix m) {
        t00 = m.t00;
        t01 = m.t01;
        t02 = m.t02;
        t03 = m.t03;
        
        t10 = m.t10;
        t11 = m.t11;
        t12 = m.t12;
        t13 = m.t13;
        
        t20 = m.t20;
        t21 = m.t21;
        t22 = m.t22;
        t23 = m.t23;
        toFP();
    }
    
    
    public final void toFP() { //переводим в fixedpoint
        m00 = (int)(t00*fp);
        m01 = (int)(t01*fp);
        m02 = (int)(t02*fp);
        m03 = (int)t03;
        
        m10 = (int)(t10*fp);
        m11 = (int)(t11*fp);
        m12 = (int)(t12*fp);
        m13 = (int)t13;
        
        m20 = (int)(t20*fp);
        m21 = (int)(t21*fp);
        m22 = (int)(t22*fp);
        m23 = (int)t23;
        
        //System.out.println("X  "+ Math.sqrt(m00*m00 + m10*m10 + m20*m20) );
        //System.out.println("Y  "+ Math.sqrt(m01*m01 + m11*m11 + m21*m21) );
        //System.out.println("Z  "+ Math.sqrt(m02*m02 + m12*m12 + m22*m22) );
        //System.out.println("  ");
        //System.out.println("  ");
    }
    
    
    
}