package com.iceberg;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */



/**
 * @author DDDEN!SSS
 */
public class Vertex { //класс вершина
    public short xReal,  yReal,  zReal; //стандартные 3D координаты
    public int x,  y,  z; //повёрнутые 3D координаты
    public short sx,  sy; //координаты на дисплее
    
    public Vertex(String ver) {
        int t1 = ver.indexOf(",", 0);
        int t2 = ver.indexOf(",", t1+1);
                
        String xStr = ver.substring(0, t1);
        String yStr = ver.substring(t1+1, t2);
        String zStr = ver.substring(t2+1, ver.length());
                
        x = xReal = Short.parseShort(xStr);
        y = yReal = Short.parseShort(yStr);
        z = zReal = Short.parseShort(zStr);
        
        set2D();
    }
    
    
    
    
    private final void set2D() {
        int Z = Math.abs(z);
        if(Z == 0) {
            Z=1;
        }
        sx = (short)(G3D.centreX + x * G3D.persX / Z);
        sy = (short)(G3D.centreY + y * G3D.persY / Z);
    }
    
    
    
    
    
    public final void setMatrix(Matrix m) {
        x = (xReal*m.m00 + yReal*m.m01 + zReal*m.m02)>>12; //умножаем вершину на все вектора матрицы
        y = (xReal*m.m10 + yReal*m.m11 + zReal*m.m12)>>12;
        z = (xReal*m.m20 + yReal*m.m21 + zReal*m.m22)>>12;
        
        x += m.m03;//перемещаем вершину
        y += m.m13;
        z += m.m23;
        
        set2D();
    }
    
    
    
    
    
    
    
}